package org.jboss.security;

package .tmp;

import java.security.CodeSource;
import java.security.PermissionCollection;
import java.security.Permissions;
import java.security.Principal;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;
import javax.security.auth.Subject;

public class AuthorizationInfo {
  private static Set emptySet = new HashSet();
  
  private ArrayList policyMap = new ArrayList();
  
  private PolicyEntry[] policyEntries;
  
  public PermissionCollection getPermissions(Subject subject, CodeSource codesource) {
    PermissionCollection perms = new Permissions();
    Set subjectPrincipals = emptySet;
    if (subject != null)
      subjectPrincipals = subject.getPrincipals(); 
    for (int n = 0; n < this.policyMap.size(); n++) {
      PolicyEntry entry = this.policyMap.get(n);
      if (entry.implies(codesource, subjectPrincipals) == true)
        entry.getPermissions(perms); 
    } 
    return perms;
  }
  
  public String toString() {
    StringBuffer buffer = new StringBuffer("permissions:");
    return buffer.toString();
  }
  
  public void grant(CodeSource cs, ArrayList permissions) {
    grant(cs, permissions, null);
  }
  
  public void grant(CodeSource cs, ArrayList permissions, Principal[] principals) {
    PolicyEntry entry = new PolicyEntry(cs, principals, permissions);
    this.policyMap.add(entry);
  }
}
